
#ifndef _include_bleifrei_gfx_RenderTarget_hpp_
#define _include_bleifrei_gfx_RenderTarget_hpp_ 


// includes
#include "opengl.hpp"

namespace bleifrei {
	namespace gfx {

		class RenderTarget {
		public:
			enum Format {
				rgb8,
				rgba8,
				rgba8rect,
				rgba8db,
				rgba8dbrect,
				rgb16f,
				rgb16frect
			};

			enum Buffer {
				Front = WGL_FRONT_LEFT_ARB,
				Back = WGL_BACK_LEFT_ARB
			};

			int getWidth(void) const											{ return width;						}
			int getHeight(void) const											{ return height;					}
			int getBitdepth(void) const											{ return bpp;						}

			void swapBuffers(void);

		protected:
			RenderTarget(void) : doubleBuffered(false), hRC(NULL), hDC(NULL), width(0), height(0), bpp(0) {}
			virtual ~RenderTarget(void) {}

			void activate(void);

			int width, height;
			int bpp;
			bool doubleBuffered;

			// windows specific
		public:
			// $TODO: hide these
			HDC windows_getDeviceContextHandle(void)							{ return hDC;						}
			HGLRC windows_getGLRenderingContextHandle(void)						{ return hRC;						}
		protected:
			HGLRC hRC;
			HDC hDC;
		};
	
	}
}


#endif //_include_bleifrei_gfx_RenderTarget_hpp_
