
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/tex/Texture.hpp"

#include "ProgressIndicator.hpp"

using namespace bleifrei::tex;

ProgressIndicator::ProgressIndicator(int x, int y, int width, int height)
{
	move(x, y);
	resize(width, height);
}

ProgressIndicator::~ProgressIndicator(void)
{
}

void ProgressIndicator::onPaintBackground(int absx, int absy)
{
/*	glColor4f(0.0f, 0.0f, 0.0f, 0.5f);

	glBegin(GL_QUADS);
		glVertex2i(absx, absy);
		glVertex2i(absx, absy + getHeight());
		glVertex2i(absx + getWidth(), absy + getHeight());
		glVertex2i(absx + getWidth(), absy);
	glEnd();*/
}

void ProgressIndicator::onPaintOverlay(int absx, int absy)
{
	const int space = 2;
	int xpos = (int)((isVertical() ? 1 : position) * (getWidth() - 2 * space));
	int ypos = (int)((isVertical() ? position : 1) * (getHeight() - 2 * space));

	nullTexture->bind();

	glColor4f(192 / 255.0f, 192 / 255.0f, 192 / 255.0f, 1.0f);
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_QUADS);
		glVertex2i(absx, absy);
		glVertex2i(absx, absy + getHeight() - 1);
		glVertex2i(absx + getWidth() - 1, absy + getHeight() - 1);
		glVertex2i(absx + getWidth() - 1, absy);
	glEnd();
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);

	glColor4f(98 / 255.0f, 142 / 255.0f, 181 / 255.0f, 1.0f);
	glBegin(GL_QUADS);
		glVertex2i(absx + space, absy - space + getHeight() - 1 - ypos);
		glVertex2i(absx + space, absy - space + getHeight() - 1);
		glVertex2i(absx + space + xpos, absy - space + getHeight() - 1);
		glVertex2i(absx + space + xpos, absy - space + getHeight() - 1 - ypos);
	glEnd();

/*	glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
	glBegin(GL_LINE_LOOP);
		glVertex2i(absx + space, absy - space + getHeight() - ypos);
		glVertex2i(absx + space, absy - space + getHeight());
		glVertex2i(absx + space + xpos, absy - space + getHeight());
		glVertex2i(absx + space + xpos, absy - space + getHeight() - ypos);
	glEnd();*/
}
